<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="隐患类别" prop="declarationType" style="width: 308px">
        <el-select v-model="queryParams.declarationType" placeholder="请选择隐患类别" clearable>
          <el-option v-for="dict in hs_declaration_type" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item label="发生时间" style="width: 308px">
        <el-date-picker v-model="daterangeOccurTime" value-format="YYYY-MM-DD" type="daterange" range-separator="-"
          start-placeholder="开始日期" end-placeholder="结束日期"></el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <!-- <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['sidebar:safetyDeclaration:add']"
        >新增</el-button>
      </el-col> -->
      <!-- <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['sidebar:safetyDeclaration:edit']"
        >修改</el-button>
      </el-col> -->
      <!-- <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['sidebar:safetyDeclaration:remove']"
        >删除</el-button>
      </el-col> -->
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport"
          v-hasPermi="['sidebar:safetyDeclaration:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="safetyDeclarationList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="序号" align="center" prop="id" />
      <el-table-column label="隐患类别" align="center" prop="declarationType">
        <template #default="scope">
          <dict-tag :options="hs_declaration_type" :value="scope.row.declarationType" />
        </template>
      </el-table-column>
      <el-table-column label="隐患内容" align="center" prop="requirementDescription" />
      <el-table-column label="隐患图片" align="center" prop="declarationImg" width="100">
        <template #default="scope">
          <image-preview :src="scope.row.declarationImg" :width="50" :height="50" />
        </template>
      </el-table-column>
      <el-table-column label="发生时间" align="center" prop="occurTime" width="180">
        <template #default="scope">
          <span>{{ parseTime(scope.row.occurTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <!-- <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['sidebar:safetyDeclaration:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['sidebar:safetyDeclaration:remove']">删除</el-button> -->
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
            v-hasPermi="['sidebar:safetyDeclaration:remove']">查看详情</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize"
      @pagination="getList" />

    <!-- 添加或修改水电校园安全不良事件
对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="safetyDeclarationRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="隐患类别" prop="declarationType">
          <el-select v-model="form.declarationType" placeholder="请选择隐患类别" disabled>
            <el-option v-for="dict in hs_declaration_type" :key="dict.value" :label="dict.label"
              :value="dict.value"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="巡检要求" prop="requirementDescription">
          <el-input v-model="form.requirementDescription" placeholder="请输入巡检要求" disabled />
        </el-form-item>
        <el-form-item label="隐患图片" prop="declarationImg">
          <!-- <image-upload v-model="form.declarationImg"/> -->
          <el-image style="width: 200px; height: 200px" :src="url" :preview-src-list="srcList" fit="cover" />
        </el-form-item>
        <el-form-item label="申请人" prop="applyUser">
          <el-input v-model="form.applyUser" placeholder="请输入申请人" disabled />
        </el-form-item>
        <el-form-item label="发生时间" prop="occurTime">
          <el-date-picker clearable disabled v-model="form.occurTime" type="date" value-format="YYYY-MM-DD"
            placeholder="请选择发生时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="备注" prop="remark" disabled>
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="SafetyDeclaration">
import { listSafetyDeclaration, getSafetyDeclaration, delSafetyDeclaration, addSafetyDeclaration, updateSafetyDeclaration } from "@/api/sidebar/safetyDeclaration";


const { proxy } = getCurrentInstance();
const { hs_declaration_type } = proxy.useDict('hs_declaration_type');

const safetyDeclarationList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const daterangeOccurTime = ref([]);


const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    declarationType: null,
    occurTime: null,
  },
  rules: {
    occurTime: [
      { required: true, message: "发生时间不能为空", trigger: "blur" }
    ],
    currentState: [
      { required: true, message: "当前状态不能为空", trigger: "change" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

const url = ref()
const srcList = ref([]);
//初始化图片
const groupedImages = ((ig) => {
  srcList.value = [];
  url.value = "";
  if (ig.value !== "") { // 确保输入不为空  
    const imageArray = ig.declarationImg.split(",");
    imageArray.forEach(element => {
      srcList.value.push("http://localhost/dev-api" + element);
    });
    console.log(srcList.value[0]);
    url.value = srcList.value[0]
  }
})


/** 查询水电校园安全不良事件
列表 */
function getList() {
  loading.value = true;
  queryParams.value.params = {};
  if (null != daterangeOccurTime && '' != daterangeOccurTime) {
    queryParams.value.params["beginOccurTime"] = daterangeOccurTime.value[0];
    queryParams.value.params["endOccurTime"] = daterangeOccurTime.value[1];
  }
  listSafetyDeclaration(queryParams.value).then(response => {
    safetyDeclarationList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    id: null,
    declarationType: null,
    requirementDescription: null,
    declarationImg: null,
    applyUser: null,
    occurTime: null,
    solveUser: null,
    solveTime: null,
    currentState: null,
    remark: null
  };
  proxy.resetForm("safetyDeclarationRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  daterangeOccurTime.value = [];
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加水电校园安全不良事件";
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _id = row.id || ids.value
  getSafetyDeclaration(_id).then(response => {
    form.value = response.data;
    groupedImages(response.data);
    open.value = true;
    title.value = "修改水电校园安全不良事件";
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["safetyDeclarationRef"].validate(valid => {
    if (valid) {
      if (form.value.id != null) {
        updateSafetyDeclaration(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addSafetyDeclaration(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _ids = row.id || ids.value;
  proxy.$modal.confirm('是否确认删除水电校园安全不良事件编号为"' + _ids + '"的数据项?').then(function () {
    return delSafetyDeclaration(_ids);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => { });
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('sidebar/safetyDeclaration/export', {
    ...queryParams.value
  }, `safetyDeclaration_${new Date().getTime()}.xlsx`)
}

getList();
</script>
